--------------------------------------------------------------------------------
-- GLOBALS
--------------------------------------------------------------------------------

Global( "wtMainPanel", nil )
Global( "delta", 10 )
Global( "COUNTER_LIMIT", 5 )
Global( "counter", COUNTER_LIMIT )
Global( "wtTextView", nil )
Global( "wtTextViewA", nil )
Global( "wtTextViewB", nil )
Global( "wtTextViewC", nil )
Global( "wtTextViewD", nil )
Global( "wtTextViewE", nil )
Global( "wtTextViewF", nil )
Global( "wtTextViewG", nil )
Global( "wtTextViewK", nil )
Global( "wtMainPanelDNDId", 0 )
Global( "bMainPanelMovable", false )

Global( "DamageData", {
	["DamageAmount"] = 0,
	["FightTime"] = 0,
	["DamageBlocked"] = 0,
	["DamageParry"] = 0,
	["DamageResist"] = 0,
	["DamageAbsorb"] = 0,
	["DamagePhysic"] =0,
	["DamageFire"] =0,
	["DamageCold"] = 0,
	["DamageLIGHTNING"] = 0,
	["DamageHOLY"] = 0,
	["DamageSHADOW"] =0,
	["DamageASTRAL"] = 0,
	["DamagePOISON"] =0,
	["DamageDISEASE"] = 0,
	["DamageACID"] = 0,
	["DamageCrit"] = 0,
	["bCollectData"] = false
} )
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
function SetDPSMeterValues()
	wtTextView:SetVal( "DamageDone", common.FormatInt( DamageData["DamageAmount"] , "%d" ) )
	wtTextView:SetVal( "DPS", common.FormatFloat( (DamageData["DamageAmount"] / DamageData["FightTime"]), "%.2f" ) )
  wtTextViewA:SetVal( "Parry",common.FormatFloat(  DamageData["DamageParry"]/DamageData["DamageAmount"]*100, "%.2f" ) )
  wtTextViewA:SetVal( "Block",common.FormatFloat(  DamageData["DamageBlocked"]/DamageData["DamageAmount"]*100, "%.2f" ) )
  wtTextViewB:SetVal( "Resist",common.FormatFloat(  DamageData["DamageResist"]/DamageData["DamageAmount"]*100, "%.2f" ) )
  wtTextViewB:SetVal( "Absorb",common.FormatFloat(  DamageData["DamageAbsorb"]/DamageData["DamageAmount"]*100, "%.2f" ) )
  wtTextViewC:SetVal( "Physic",common.FormatFloat(  DamageData["DamagePhysic"]/DamageData["DamageAmount"]*100, "%.2f" ) )
  wtTextViewC:SetVal( "Fire",common.FormatFloat(  DamageData["DamageFire"]/DamageData["DamageAmount"]*100, "%.2f" ) )
  wtTextViewD:SetVal( "Cold",common.FormatFloat(  DamageData["DamageCold"]/DamageData["DamageAmount"]*100, "%.2f" ) )
  wtTextViewD:SetVal( "LIGHTNING",common.FormatFloat(  DamageData["DamageLIGHTNING"]/DamageData["DamageAmount"]*100, "%.2f" ) )
  wtTextViewE:SetVal( "HOLY",common.FormatFloat(  DamageData["DamageHOLY"]/DamageData["DamageAmount"]*100, "%.2f" ) )
  wtTextViewE:SetVal( "SHADOW",common.FormatFloat(  DamageData["DamageSHADOW"]/DamageData["DamageAmount"]*100, "%.2f" ) )
  wtTextViewF:SetVal( "ASTRAL",common.FormatFloat(  DamageData["DamageASTRAL"]/DamageData["DamageAmount"]*100, "%.2f" ) )
  wtTextViewF:SetVal( "POISON",common.FormatFloat(  DamageData["DamagePOISON"]/DamageData["DamageAmount"]*100, "%.2f" ) )
  wtTextViewG:SetVal( "DISEASE",common.FormatFloat(  DamageData["DamageDISEASE"]/DamageData["DamageAmount"]*100, "%.2f" ) )
  wtTextViewG:SetVal( "ACID",common.FormatFloat(  DamageData["DamageACID"]/DamageData["DamageAmount"]*100, "%.2f" ) )
  wtTextViewK:SetVal( "CRIT",common.FormatFloat(  DamageData["DamageCrit"]/DamageData["DamageAmount"]*100, "%.2f" ) )
--  LogInfo( common.FormatFloat(  DamageData["DamageCrit"]/DamageData["DamageAmount"]*100, "%.2f" )  )
end
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
-- REACTION HANDLERS
--------------------------------------------------------------------------------
 -- "EVENT_SECOND_TIMER"
function OnEventSecondTimer( params )
	if ( DamageData["bCollectData"] ) then
		DamageData["FightTime"] = DamageData["FightTime"] + 1
	end
end
--------------------------------------------------------------------------------
function onAvatarCombatStatusChanged( params )
	if params.inCombat then 
		DamageData["DamageAmount"] = 0
		DamageData["FightTime"] = 0  
    DamageData["DamageBlocked"] = 0 
    DamageData["DamageParry"] = 0
    DamageData["DamageResist"] = 0
    DamageData["DamageAbsorb"] = 0
    DamageData["DamagePhysic"] = 0
    DamageData["DamageFire"] = 0
    DamageData["DamageCold"] = 0
    DamageData["DamageLIGHTNING"] = 0
    DamageData["DamageHOLY"] = 0
    DamageData["DamageSHADOW"] = 0
    DamageData["DamageASTRAL"] = 0
    DamageData["DamagePOISON"] = 0
    DamageData["DamageDISEASE"] = 0
    DamageData["DamageACID"] = 0
    DamageData["DamageCrit"] = 0
		DamageData["bCollectData"] = true
	else
		DamageData["bCollectData"] = false
		SetDPSMeterValues()

	end
end
function onDamageReceived( params )
local db = 0
	if params then
		if (params.target) and ( params.target == avatar.GetId() ) then

			if params.amount then 
				DamageData["DamageAmount"] = DamageData["DamageAmount"] + params.amount
				DamageData["DamageBlocked"] = DamageData["DamageBlocked"] + params.shieldBlock
				DamageData["DamageParry"] = DamageData["DamageParry"] + params.parry
				DamageData["DamageResist"] = DamageData["DamageResist"] + params.resist
			  DamageData["DamageAbsorb"] = DamageData["DamageAbsorb"] +  params.absorb

			--------------------
      ---  
      --------------------	
        if params.isCritical == true then
				  DamageData["DamageCrit"] = DamageData["DamageCrit"] +  params.amount
	       end  
	       ---------------------
--			LogInfo( params.sysSubElement )	
				if params.sysSubElement == "ENUM_SubElement_PHYSICAL" then
				  DamageData["DamagePhysic"] = DamageData["DamagePhysic"] +  params.amount
	       end  
	   ----------------------------    
     --"ENUM_SubElement_FIRE"
     ----------------------------
        if params.sysSubElement == "ENUM_SubElement_FIRE" then
				  DamageData["DamageFire"] = DamageData["DamageFire"] +  params.amount
	       end

     ----------------------------    
     --"ENUM_SubElement_COLD"
     ----------------------------
        if params.sysSubElement == "ENUM_SubElement_COLD" then
				  DamageData["DamageCold"] = DamageData["DamageCold"] +  params.amount
	       end
	   ----------------------------    
     --"ENUM_SubElement_LIGHTNING"
     ----------------------------
        if params.sysSubElement == "ENUM_SubElement_LIGHTNING" then
				  DamageData["DamageLIGHTNING"] = DamageData["DamageLIGHTNING"] +  params.amount
	       end   
     ----------------------------    
     --"ENUM_SubElement_HOLY"
     ----------------------------
        if params.sysSubElement == "ENUM_SubElement_HOLY" then
				  DamageData["DamageHOLY"] = DamageData["DamageHOLY"] +  params.amount
	       end  
     ----------------------------    
     --"ENUM_SubElement_SHADOW"
     ----------------------------
        if params.sysSubElement == "ENUM_SubElement_SHADOW" then
				  DamageData["DamageSHADOW"] = DamageData["DamageSHADOW"] +  params.amount
	       end  
     ----------------------------    
     --"ENUM_SubElement_ASTRAL"
     ----------------------------
        if params.sysSubElement == "ENUM_SubElement_ASTRAL" then
				  DamageData["DamageASTRAL"] = DamageData["DamageASTRAL"] +  params.amount
	       end  
     ----------------------------    
     --"ENUM_SubElement_POISON"
     ----------------------------
        if params.sysSubElement == "ENUM_SubElement_POISON" then
				  DamageData["DamagePOISON"] = DamageData["DamagePOISON"] +  params.amount
	       end  
     ----------------------------    
     --"ENUM_SubElement_DISEASE"
     ----------------------------
        if params.sysSubElement == "ENUM_SubElement_DISEASE" then
				  DamageData["DamageDISEASE"] = DamageData["DamageDISEASE"] +  params.amount
	       end  
     ----------------------------    
     --"ENUM_SubElement_ACID"
     ----------------------------
        if params.sysSubElement == "ENUM_SubElement_ACID" then
				  DamageData["DamageACID"] = DamageData["DamageACID"] +  params.amount
	       end  
      SetDPSMeterValues()   

       
    	end
		end
	end

end
-- "execute"
function OnReactionExecute( params )
	wtMainPanel:Show(false)

end
function OnReactionExecuteA( params )
	wtMainPanel:Show(true)
end
function MoveAllUIElements( posX, posY )
	local MainPanelPlacement = wtMainPanel:GetPlacementPlain()
	MainPanelPlacement.posX = posX
	MainPanelPlacement.posY = posY
	wtMainPanel:SetPlacementPlain( MainPanelPlacement )

end
function OnEventDNDPickAttempt( params )
	if params.srcId == wtMainPanelDNDId then 
		bMainPanelMovable = true
	else
		bMainPanelMovable = false
	end
end
function OnEventDNDDragTo( params )
	if bMainPanelMovable then
		MoveAllUIElements( params.posX, params.posY )
	end
end
function OnEventDNDDropAttempt( params )	
	bMainPanelMovable = false
	mission.DNDConfirmDropAttempt()
end
function GetDNDId( container, item )
	wtMainPanelDNDId = container * DND_CONTAINER_STEP + item
	return wtMainPanelDNDId
end
--------------------------------------------------------------------------------
-- INITIALIZATION
--------------------------------------------------------------------------------
function Init()
	  	common.RegisterReactionHandler( OnReactionExecute, "execute" ) 
	  	common.RegisterReactionHandler( OnReactionExecuteA, "executeA" ) 
  	common.RegisterEventHandler( OnEventSecondTimer, "EVENT_SECOND_TIMER" ) 
	common.RegisterEventHandler( onDamageReceived, "EVENT_UNIT_DAMAGE_RECEIVED" )
	common.RegisterEventHandler( onAvatarCombatStatusChanged, "EVENT_AVATAR_COMBAT_STATUS_CHANGED" )
  	common.RegisterEventHandler( OnEventDNDDragTo, "EVENT_DND_DRAG_TO" )
	common.RegisterEventHandler( OnEventDNDDropAttempt, "EVENT_DND_DROP_ATTEMPT" )
	common.RegisterEventHandler( OnEventDNDPickAttempt, "EVENT_DND_PICK_ATTEMPT" )
	
	wtMainPanel = mainForm:GetChildChecked( "MainPanel", false )

  wtMainPanel:Show(true)
	wtTextView = wtMainPanel:GetChildChecked( "TextView", false )
  wtTextViewA = wtMainPanel:GetChildChecked( "TextViewA", false )
  wtTextViewB = wtMainPanel:GetChildChecked( "TextViewB", false )
  wtTextViewC = wtMainPanel:GetChildChecked( "TextViewC", false )
  wtTextViewD = wtMainPanel:GetChildChecked( "TextViewD", false )
  wtTextViewE = wtMainPanel:GetChildChecked( "TextViewE", false )
  wtTextViewF = wtMainPanel:GetChildChecked( "TextViewF", false )
  wtTextViewG = wtMainPanel:GetChildChecked( "TextViewG", false )
   wtTextViewK = wtMainPanel:GetChildChecked( "TextViewK", false )
    	mission.DNDRegister( wtMainPanel, GetDNDId( DND_WIDGET_MOVE, 667 ), false )
	  SetDPSMeterValues()
    	MoveAllUIElements( 20, 210 )
--	LogInfo( "New Version!" )

	
	
end
--------------------------------------------------------------------------------
Init()
--------------------------------------------------------------------------------
